searchNodes=[{"doc":"Documentation for Castle .","ref":"Castle.html","title":"Castle","type":"module"},{"doc":"","ref":"Castle.html#commit/1","title":"Castle.commit/1","type":"function"},{"doc":"","ref":"Castle.html#generate/1","title":"Castle.generate/1","type":"function"},{"doc":"","ref":"Castle.html#install/1","title":"Castle.install/1","type":"function"},{"doc":"","ref":"Castle.html#make_releases/0","title":"Castle.make_releases/0","type":"function"},{"doc":"","ref":"Castle.html#releases/0","title":"Castle.releases/0","type":"function"},{"doc":"","ref":"Castle.html#remove/1","title":"Castle.remove/1","type":"function"},{"doc":"","ref":"Castle.html#unpack/1","title":"Castle.unpack/1","type":"function"},{"doc":"Runtime support for hot-code upgrades. Castle provides runtime support for hot-code upgrades. In particular, it generates a valid sys.config from runtime.exs and/or other Config Providers prior to both boot and hot-code upgrade. It relies on Forecastle for build-time release generation and brings it in as a build-time dependency.","ref":"readme.html","title":"Castle","type":"extras"},{"doc":"The package can be installed by adding castle to your list of dependencies in mix.exs . For projects that don't define a release, but use the appup compiler, it's sufficient to bring Castle in as a build-time dependency: def deps do [ { :castle , &quot;~&gt; 0.3.0&quot; , runtime : false } ] end For projects that do define one or more releases, Castle should be brought in as a runtime dependency: def deps do [ { :castle , &quot;~&gt; 0.3.0&quot; } ] end Castle brings in Forecastle as a build-time dependency.","ref":"readme.html#installation","title":"Castle - Installation","type":"extras"},{"doc":"Build-time integration is done via Forecastle and more details can be found in its documentation but, in summary, it will integrate into your release process via the release assembly process. In particular, it requires that that the Forecastle.pre_assemble/1 and Forecastle.post_assemble/1 functions are placed around the :assemble step, e.g.: defp releases do [ myapp : [ include_executables_for : [ :unix ] , steps : [ &amp; Forecastle . pre_assemble / 1 , :assemble , &amp; Forecastle . post_assemble / 1 , :tar ] ] ] end","ref":"readme.html#integration","title":"Castle - Integration","type":"extras"},{"doc":"The script in the bin folder supports some extra commands to manage upgrades. Releases, in their tarred-gzipped form, should first be copied to the releases subfolder on the target system. The following commands can be used to manage them: releases - Lists the releases on the system and their status. Status can be one of the following: permanent - the release the system will boot into on next restart. current - if it exists, represents the current running release. Will be different from the permanent version if a new release has been installed but not yet committed. If no version is listed as current, the permanent version is the currently running version. old - if it exists, a previously installed version. unpacked - an unpacked version, but not yet installed. unpack &lt;vsn&gt; - Unpacks the release called &lt;name&gt;-&lt;vsn&gt;.tar.gz . install &lt;vsn&gt; - Installs the new release. This makes the release the current one, but not yet the permanent one. Prior to running the relup, Castle generates the version specific sys.config for the new version. commit &lt;vsn&gt; - Makes the specified release the one the permanent one. remove &lt;vsn&gt; - Remove an old version from the filesystem. Any files shared with remaining releases are left untouched.","ref":"readme.html#release-management","title":"Castle - Release Management","type":"extras"},{"doc":"You are responsible for writing the appup scripts for your application, but Castle will copy the appup into the ebin folder for you. The steps are as follows: Write a file, in Elixir form , describing the application upgrade. e.g.: # You can call the file what you like, e.g. appup.ex, # but you should # keep it away from the compiler paths. { &#39;0.1.1&#39; , [ { &#39;0.1.0&#39; , [ { :update , MyApp.Server , { :advanced , [ ] } } ] } ] , [ { &#39;0.1.0&#39; , [ { :update , MyApp.Server , { :advanced , [ ] } } ] } ] } This file will typically be checked in to SCM. Add the appup file to the Mix project definition in mix.exs and add the :appup compiler. # Mix.exs def project do [ appup : &quot;appup.ex&quot; , # Relative to the project root. compilers : Mix . compilers ( ) ++ [ :appup ] ] end","ref":"readme.html#the-appup-compiler","title":"Castle - The Appup Compiler","type":"extras"},{"doc":"Castle contains a mix task, castle.relup , that simplifies the generation of the relup file. Assuming you have two unpacked releases e.g. 0.1.0 and 0.1.1 and you wish to generate a relup between them: &gt; mix castle.relup --target myapp/releases/0.1.1/myapp --fromto myapp/releases/0.1.0/myapp If the generated file is in the project root, it will be copied during post-assembly to the release.","ref":"readme.html#relup-generation","title":"Castle - Relup Generation","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Move build time support into Forecastle","ref":"changelog.html#0-3-0-may-27-2023","title":"Changelog - 0.3.0 - May 27, 2023","type":"extras"},{"doc":"Fix bug in shell script that prevented execution on Linux","ref":"changelog.html#0-2-3-may-21-2023","title":"Changelog - 0.2.3 - May 21, 2023","type":"extras"},{"doc":"Update Changelog","ref":"changelog.html#0-2-2-may-21-2023","title":"Changelog - 0.2.2 - May 21, 2023","type":"extras"},{"doc":"Update README","ref":"changelog.html#0-2-1-may-21-2023","title":"Changelog - 0.2.1 - May 21, 2023","type":"extras"},{"doc":"Added support for Config Provider expansion","ref":"changelog.html#0-2-0-may-21-2023","title":"Changelog - 0.2.0 - May 21, 2023","type":"extras"},{"doc":"Initial revision","ref":"changelog.html#0-1-3-may-16-2023","title":"Changelog - 0.1.3 - May 16, 2023","type":"extras"}]